---
title: Get users
slug: opti-id/api/get-users
docTags: 
createdAt: 2026-10-01T19:58:50.958Z
---

{
  "id": "HmiRduBMijwK01CtBCCRY",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://usermgmt-api.optimizely.com/api/users",
    "servers": [
      {
        "url": "https://usermgmt-api.optimizely.com/api/users"
      }
    ],
    "name": "Get users",
    "description": "Get a page of users.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "includeExternalStatus",
          "type": "boolean",
          "description": "Include the external status of the user."
        },
        {
          "kind": "optional",
          "name": "externalUserId",
          "type": "string",
          "description": "External ID of the user."
        },
        {
          "kind": "optional",
          "name": "firstName",
          "type": "string",
          "description": "First name of the user."
        },
        {
          "kind": "optional",
          "name": "lastName",
          "type": "string",
          "description": "Last name of the user."
        },
        {
          "kind": "optional",
          "name": "email",
          "type": "string",
          "description": "Email address of the user."
        },
        {
          "kind": "optional",
          "name": "homeOrganizationId",
          "type": "string",
          "description": "ID of the home organization the user belongs to."
        },
        {
          "kind": "optional",
          "name": "organizationId",
          "type": "string",
          "description": "ID of an organization the user collaborates in."
        },
        {
          "kind": "optional",
          "name": "userGroupIds",
          "type": "array",
          "description": "IDs of the user groups the user belongs to.",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "userIds",
          "type": "array",
          "description": "IDs of the users.",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "matchAnyUserGroups",
          "type": "boolean",
          "description": "Set to true to filter the results by membership in any of the userGroupIds you specify. Set to false to filter the results by membership in all of the userGroupIds you specify."
        },
        {
          "kind": "optional",
          "name": "properties",
          "type": "array",
          "description": "Properties of the user.",
          "schema": [
            {
              "name": "name",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "value",
              "kind": "optional",
              "type": "string",
              "description": ""
            }
          ],
          "itemType": "object",
          "customType": "object[]"
        },
        {
          "kind": "optional",
          "name": "isVirtual",
          "type": "boolean",
          "description": ""
        },
        {
          "kind": "optional",
          "name": "beforeLastLoggedIn",
          "type": "string",
          "description": "Filter users whose last logged in date is on or before this date."
        },
        {
          "kind": "optional",
          "name": "afterLastLoggedIn",
          "type": "string",
          "description": "Filter users whose last logged in date is on or after this date."
        },
        {
          "kind": "optional",
          "name": "size",
          "type": "integer<int32>",
          "description": "Number of results to include per page.",
          "format": "int32"
        },
        {
          "kind": "optional",
          "name": "offset",
          "type": "integer<int32>",
          "description": "Offset paging of results.",
          "format": "int32"
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "oidc_auth",
          "name": "oidc_auth",
          "kind": "optional",
          "type": "oauth2",
          "oauth2Flows": {
            "authorizationCode": {
              "authorizationUrl": "https://login.optimizely.com/oauth2/default/v1/authorize",
              "tokenUrl": "https://login.optimizely.com/oauth2/default/v1/token",
              "scopes": {
                "openid": "Identifies the request as an OpenID Connect request (required)",
                "profile": "Requests access to the end user's default profile claims",
                "email": "Requests access to the email and email_verified claims",
                "offline_access": "Requests a refresh token used to obtain more access tokens without re-prompting the user for authentication",
                "idx_instancepermissions": "Request Instance Permissions claim for use with Optimizely Products"
              }
            }
          },
          "requiredScopes": [
            "openid",
            "profile",
            "email",
            "offline_access",
            "idx_instancepermissions"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "The users response.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "page_optiIdUser",
            "schema": [
              {
                "name": "totalItemCount",
                "kind": "optional",
                "type": "integer<int32>",
                "nullable": true,
                "description": "",
                "format": "int32"
              },
              {
                "name": "items",
                "kind": "optional",
                "type": "array",
                "nullable": true,
                "description": "",
                "modelRef": "#/components/schemas/optiIdUser",
                "customType": "optiIdUser[]",
                "schema": [
                  {
                    "name": "externalStatus",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "id",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "externalUserId",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "firstName",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "lastName",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "email",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "homeOrganizationId",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "userGroupIds",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "lastLoggedIn",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  },
                  {
                    "name": "created",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  },
                  {
                    "name": "modified",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  },
                  {
                    "name": "properties",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "modelRef": "#/components/schemas/property",
                    "customType": "property[]",
                    "schema": [
                      {
                        "name": "name",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      },
                      {
                        "name": "value",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      }
                    ]
                  },
                  {
                    "name": "isLocalInSSO",
                    "kind": "optional",
                    "type": "boolean",
                    "description": ""
                  },
                  {
                    "name": "isVirtual",
                    "kind": "optional",
                    "type": "boolean",
                    "description": ""
                  },
                  {
                    "name": "links",
                    "kind": "optional",
                    "type": "array",
                    "nullable": true,
                    "description": "",
                    "modelRef": "#/components/schemas/link",
                    "customType": "link[]",
                    "schema": [
                      {
                        "name": "rel",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      },
                      {
                        "name": "href",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      }
                    ]
                  }
                ]
              },
              {
                "name": "links",
                "kind": "optional",
                "type": "array",
                "nullable": true,
                "description": "",
                "modelRef": "#/components/schemas/link",
                "customType": "link[]",
                "schema": [
                  {
                    "name": "rel",
                    "kind": "optional",
                    "type": "string",
                    "nullable": true,
                    "description": ""
                  },
                  {
                    "name": "href",
                    "kind": "optional",
                    "type": "string",
                    "nullable": true,
                    "description": ""
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/page_optiIdUser",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "The request was invalid or cannot be otherwise served. An accompanying error message will explain further.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "array",
            "description": "",
            "customType": "validationError[]",
            "schema": [
              {
                "name": "field",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": ""
              },
              {
                "name": "code",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": ""
              },
              {
                "name": "message",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/validationError",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized access to endpoint.",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden access to endpoint.",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "500",
        "description": "<p>A server error occurred, please try again.</p>",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "yjGBkKjK1AQNUDqb0dlUk",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url 'https://usermgmt-api.optimizely.com/api/users?properties=array' \\\n     --header 'accept: application/json'"
        },
        {
          "id": "OZQIdYjUA3v-0vWjQ8m2P",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://usermgmt-api.optimizely.com/api/users?properties=array\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "qiUFhnT0nmJbvUFz6XmLB",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://usermgmt-api.optimizely.com/api/users?properties=array\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "KncH8Dzx_JBpiEDwyf8sp",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://usermgmt-api.optimizely.com/api/users?properties=array\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "yjGBkKjK1AQNUDqb0dlUk"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// The users response.\n{\n  \"totalItemCount\": \"\",\n  \"items\": [\n    {\n      \"externalStatus\": \"\",\n      \"id\": \"\",\n      \"externalUserId\": \"\",\n      \"firstName\": \"\",\n      \"lastName\": \"\",\n      \"email\": \"\",\n      \"homeOrganizationId\": \"\",\n      \"userGroupIds\": [\n        \"\"\n      ],\n      \"lastLoggedIn\": \"\",\n      \"created\": \"\",\n      \"modified\": \"\",\n      \"properties\": [\n        {\n          \"name\": \"\",\n          \"value\": \"\"\n        }\n      ],\n      \"isLocalInSSO\": false,\n      \"isVirtual\": false,\n      \"links\": [\n        {\n          \"rel\": \"\",\n          \"href\": \"\"\n        }\n      ]\n    }\n  ],\n  \"links\": [\n    {\n      \"rel\": \"\",\n      \"href\": \"\"\n    }\n  ]\n}"
        },
        {
          "id": "response-1-400",
          "language": "400",
          "code": "// The request was invalid or cannot be otherwise served. An accompanying error message will explain further.\n[\n  {\n    \"field\": \"\",\n    \"code\": \"\",\n    \"message\": \"\"\n  }\n]"
        },
        {
          "id": "response-2-401",
          "language": "401",
          "code": "// Unauthorized access to endpoint.\n"
        },
        {
          "id": "response-3-403",
          "language": "403",
          "code": "// Forbidden access to endpoint.\n"
        },
        {
          "id": "response-4-500",
          "language": "500",
          "code": "// A server error occurred, please try again.\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}